/************************************************************************
 *   IRC - Internet Relay Chat, modules/m_szline.c
 *
 *   Copyright (C) 2000-2003 TR-IRCD Development
 *
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Co Center
 *
 *   See file AUTHORS in IRC package for additional names of
 *   the programmers.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Id: m_szline.c,v 1.4 2003/06/14 13:55:51 tr-ircd Exp $ 
 */

#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include "h.h"
#include "s_conf.h"

static char *token = TOK1_SZLINE;

static struct Message _msgtab[] = {
    {MSG_SZLINE, 0, MAXPARA, M_SLOW, 0L,
     m_unregistered, m_ignore, m_ignore, m_szline, m_szline}
};

#ifndef STATIC_MODULES

char *_version = "$Revision: 1.4 $";

void _modinit(void)
{
    mod_add_cmd(_msgtab);
    tok1_msgtab[(u_char) *token].msg = _msgtab;
}

void _moddeinit(void)
{
    mod_del_cmd(_msgtab);
    tok1_msgtab[(u_char) *token].msg = NULL;
}
#else
void m_szline_init(void)
{
    mod_add_cmd(_msgtab);
    tok1_msgtab[(u_char) *token].msg = _msgtab;
}
#endif

int m_szline(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
    aMaskItem *ami;

    if (!(IsServer(sptr) || IsULine(sptr)))
	return 0;

    if (parc < 3) 
	return 0;

    if (!(ami = find_maskitem(parv[1], NULL, MASKITEM_ZAPLINE, 1))) {

        ami = create_maskitem(sptr->name, parv[1], NULL, MASKITEM_ZAPLINE, 0);
        if (!ami)
            return -1;

        DupString(ami->reason, parv[2]);   
    }
    sendto_serv_butone(cptr, sptr, TOK1_SZLINE, "%s :%s", parv[1], parv[2]);
    return 0;
}

