/************************************************************************
 *   IRC - Internet Relay Chat, modules/operdo/m_operdo_help.c
 *
 *   Copyright (C) 2000-2003 TR-IRCD Development
 *
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Co Center
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "struct.h"
#include "common.h"
#include "chanmode.h"
#include "sys.h"
#include "msg.h"
#include "h.h"
#include "hook.h"

static int do_operdo_help(struct hook_data *data);

#ifndef STATIC_MODULES

void _modinit(void)
{
    hook_add_hook("load operdo core module", (hookfn *) do_operdo_help);
}

void _moddeinit(void)
{
    hook_del_hook("load operdo core module", (hookfn *) do_operdo_help);
}

char *_version = "$Revision: 1.3 $";

#else

void m_operdo_help_init(void)
{
    hook_add_hook("load operdo core module", (hookfn *) do_operdo_help);
}

#endif

static int do_operdo_help(struct hook_data *data)
{

    if (irc_strcmp(data->extra, "HELP"))
	return 0;

    send_me_notice(data->source_p, ":Available commands are:");
    send_me_notice(data->source_p, ": ");
    send_me_notice(data->source_p, ":\002MODE\002 #channel params");
    send_me_notice(data->source_p, ":\002TOPIC\002 #channel :text");
    send_me_notice(data->source_p, ":\002KICK\002 #channel user :reason");
    send_me_notice(data->source_p, ":\002JOIN\002 #channel modes");

    return 1;
}
