#!/bin/sh
spitshell=cat
package="trircd-5"
md5sum=$1


echo " " > mdsums.log
echo "  MD5 checksum check..." >> mdsums.log
echo " ===================================================" >> mdsums.log
echo "Extracting $package/src/version.c..."

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

if test -r version.c.last ; then
 generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
 genesis=`sed -n 's/^char \*genesis = \"\(.*\)\";/\1/p' < version.c.last`
 if test ! "$generation" ; then 
  generation=0
 fi 
 if test ! "$genesis" ; then 
  genesis=$creation
 fi
else
 generation=0
 genesis=$creation
fi

generation=`expr $generation + 1`

uname=`uname -a | sed 's/$/\",/;s/^/   "/'`
ulimit=`ulimit -a | sed 's/$/\",/;s/^/   "/'`

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell > version.c <<!SUB!THIS!
/*
 *   IRC - Internet Relay Chat, src/version.c
 *   Copyright (C) 1990 Chelsea Ashley Dyerman
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "patchlevel.h"
#include "ircsprintf.h"
#include "init.h"

char *generation = "$generation";
char *creation = "$creation";
char version[128];

void build_version(void)
{
    char *s = PATCHES;

    ircsprintf(version, "%s(%s)-%.1d.%.1d(%.2d)%s#%s", BASENAME, BRANCH,
               MAJOR, MINOR, PATCH, (*s != 0 ? PATCHES : ""), generation);

}

char *infotext[] =
    {
	 "$package --",
	 "Based on the original code written by Jarkko Oikarinen",
	 "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
	 "",
	 "This program is free software; you can redistribute it and/or",
	 "modify it under the terms of the GNU General Public License as",
	 "published by the Free Software Foundation; either version 2, or",
	 "(at your option) any later version.",
	 "",
	 "Send bug reports to tr-ircd@users.sourceforge.net",
	 "",
         "TimeMr14C  Yusuf Iskenderoglu     Head Developer and coding",
	 "dsginosa   Dimitris Ginosatis     Coding and suggestions",    
         "Talesin    Ekim Engin             Ideas and contribution",
	 "",
	 "Special thanks to Andreas Haeberlen for his help",
 	 "in perfecting many different code sections",
	 "Special thanks to Hakan Onur because of his ideas in perfecting",
	 "different code sections",
	 "Special thanks to neXus for the documentation and suggestions",  
	 "",
	 "This ircd software contains code from Bahamut, the DALnet ircd",
	 "and from hybrid, the EFnet ircd.",
	 "Very special thanks go to the coders of these ircds.",
	 "",
	 "Thanks also go to those persons not mentioned here who have added",
	 "their advice, opinions, and code to ircd development.",
	 "Thanks also to those who provide the kind sys admins who let me and",
	 "others continue to develop ircd.",
	 "(c) By TR-IRCD Development Team 2000-2003",
    "",
	 0,
};

char *copyrighttext[] =
    {
	"TR-IRCD is Copyright (C) 2000-2003 by TR-IRCD Development Team",
 	"TR-IRCD is Copyright (C) 2002 by the past and present ircd coders, and others.",
      	"Refer to the documentation within doc/authors/ for full credits and copyrights.",
	"The archive containing this documentation can be obtained from",
	"http://tr-ircd.sourceforge.net/ http://www.tr-ircd.net",
	"",
	"This program is free software; you can redistribute it and/or modify",
	"it under the terms of the GNU General Public License as published by",
	"the Free Software Foundation; either version 2 of the License, or",
	"(at your option) any later version.",
	"",
	"This program is distributed in the hope that it will be useful,",
	"but WITHOUT ANY WARRANTY; without even the implied warranty of",
	"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the",
	"GNU General Public License for more details.",
	"",
	"A copy of the GNU General Public License are distributed alongside all",
	"official releases of UltimateIRCd. It can also be obtained by writing to",
	"Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,",
	"MA  02111-1307 USA",
	"",
	 0,
};


char *uname_result[] = {
$uname
   0
};

char *ulimit_result[] = {
$ulimit
   0
};

!SUB!THIS!


for i in `du -a .. | grep .md5sums | awk {'print $2'}` ; do
 IPATH=`echo $i | sed -e 's/\/.md5sums//'`
 NAME=`echo $IPATH | awk -F \/ {'print $NF'}`
 failed="0"
 ffiles=""
 echo "char *${NAME}sums[] = {" >> version.c

 echo -n "  Extracting checksums in $IPATH ... " >> mdsums.log
  for j in `cat $i | awk {'print $2'}`; do
   FILE=`$md5sum $IPATH/$j`
   STATUS=`grep $FILE $i | awk -F : {'print $2'}`
   if test -n "$STATUS" ; then
    echo "	\"$STATUS\"," >> version.c
   else
    echo "	\"FAILED 			   $j\"," >> version.c
    failed="1"
    ffiles="$ffiles$j "
   fi
 done

 echo "  0" >> version.c
 echo "};" >> version.c
 echo " " >> version.c
 
 if test $failed = "1" ; then
  echo "modified files detected: $ffiles" >> mdsums.log
 else
  echo "done" >> mdsums.log
 fi
done
echo " ===================================================" >> mdsums.log
echo " Finished compiling tr-ircd 5.5...  Have a good chat" >> mdsums.log
echo " " >> mdsums.log

